$(function(){
  init();
});

function init(){
  $.getScript("js/x3dom-full.debug.js",function(){
    x3dom.runtime.ready = function(){
      deep_init();
    };
  });
}

function deep_init(){
  
  var cnv = document.getElementById('x3d_id');
  //cnv.runtime.showAll();
  bind_FoV(cnv);
  bind_keys(cnv);
  
  var button = $("<button>").css({
    position:"absolute",
    top:"10px",
    right:"10px"
  }).html("Get View Position and Orientation");
  
  button.on("click",getPO);
  
  $('body').append(button);
  
}

function getPO(){
  
  var cnv = document.getElementById('x3d_id');
  var vm = cnv.runtime.viewMatrix();
  
  console.log("runtime.viewMatrix():");
  console.log(vm.toString());
  
  var vm_r = new x3dom.fields.Quaternion(0, 0, 1, 0);
  vm_r.setValue(vm);
  var vm_t = vm.e3();
  
  var translation = new x3dom.fields.SFVec3f(0,0,0);
  var scaleFactor = new x3dom.fields.SFVec3f(1,1,1);
  var rotation = new x3dom.fields.Quaternion(0,0,1,0);
  var scaleOrientation = new x3dom.fields.Quaternion(0,0,1,0);
  
  vm.getTransform(translation, rotation, scaleFactor, scaleOrientation);
  
  //console.log("backnforth:");
  //console.log(translation.toString()+" / "+rotation.toString());
  
  //look at experiment
  
  var v1 = new x3dom.fields.SFVec3f(0, 0, 5);
  var v2 = new x3dom.fields.SFVec3f(0, 0, 0);
  var v3 = new x3dom.fields.SFVec3f(0, 1, 0);
  
  var m_test = x3dom.fields.SFMatrix4f.lookAt(v1,v2,v3);
  
  //console.log(m_test.toString());
  
  var translation = v1;
  var scaleFactor = new x3dom.fields.SFVec3f(1,1,1);
  
  var m5 = cnv.runtime.getCameraToWorldCoordinatesMatrix();
  console.log(m5.toString());
  
  
  m5 = cnv.runtime.getWorldToCameraCoordinatesMatrix();
  console.log(m5.toString());
  
}

function bind_keys(elem){
  
  elem.addEventListener('keydown',function(e){
    
    var dx = 0;
    var dy = 0;
    
    var goodkey = false;
    
    if (e.keyCode=='38'){
      //console.log("up");
      dy = 1;
    }
    if (e.keyCode=='40'){
      //console.log("down");
      dy = -1;
    }
    if (e.keyCode=='37'){
      console.log("left");
      dx = -1;
      
      var vp = this.runtime.canvas.doc._viewarea;
      
      console.log(this.runtime.viewMatrix());
      
      //firstViewarea.animateTo(secondViewarea.getViewMatrix(), firstViewarea._scene.getViewpoint(), 0);
      //vp.animateTo(x3dom.fields.SFMatrix4f.identity(),vp._scene.getViewpoint(),1);
      
    }
    if (e.keyCode=='39'){
      //console.log("right");
      dx = 1;
    }
    
    if (goodkey){
      e.preventDefault();
      e.stopPropagation();
      return false;
    }
    
  },true);
}

function getViewpointPosition(elem){
  
  var vp_mat = elem.runtime.viewMatrix();
  
  var vp_rotation = new x3dom.fields.Quaternion(0, 0, 1, 0);
  vp_rotation.setValue(vp_mat);
  
  var vp_translation = vp_mat.e3();
  
  console.log(vp_translation.toString());
  
  return vp_translation;
}

function bind_FoV(elem){
  // true = CAPTURING = from parent to child
  // canvas is a child of x3d
  
  //Chrome?!
  elem.addEventListener('mousewheel',function(e){

    //if (e.ctrlKey) {

      var delta = (e.deltaY>0)?0.05:-0.05;

      fov = getFoV(this)+delta;

      setFoV(this,fov);

      e.preventDefault();
      e.stopPropagation();
      return false;
    //}
    
  },true);
  
  //Firefox?!
  elem.addEventListener('DOMMouseScroll',function(e){

    //if (e.ctrlKey) {
      
      var delta = (e.detail>0)?0.05:-0.05;

      fov = getFoV(this)+delta;

      setFoV(this,fov);

      e.preventDefault();
      e.stopPropagation();
      return false;
    //}
    
  },true);  
  
}


function setFoV(elem,val){

  var vp = $(elem).find("Viewpoint")[0];
  $(vp).prop("fieldOfView",val);
  
}

function getFoV(elem){

  var vp = $(elem).find("Viewpoint")[0];
  return parseFloat($(vp).prop("fieldOfView"));
  
}
