var HIGHLIGHT_ON_MOUSEOVER = true;

var X3DOM_SCENE_INIT = false;

$(function(){
  init();
});

function init(){
  $.getScript("js/x3dom-full.debug.js",function(){
    // init
    x3dom.runtime.ready = function(){
      deep_init();
    };
    
  });
}

function deep_init(){
  
  var cnv = document.getElementById('x3d_id');
  //cnv.runtime.showAll();
  bind_FoV(cnv);
  bind_keys(cnv);
  
  var button = $("<button>").css({
    position:"absolute",
    top:"10px",
    right:"10px"
  }).html("Get View Position and Orientation");
  
  button.on("click",bind_shapes);
  
  //$('body').append(button);
  
  cnv.runtime.enterFrame = function(){
    //the only <strong>
    var progress_element = $.find("strong");
    var progress_counter = $(progress_element).html();
    progress_counter = progress_counter.split(" ");
    cnt = parseInt(progress_counter[1]);
    
    if (!X3DOM_SCENE_INIT&&(cnt==0)){
      
      bind_shapes();
      initShapeTitle();
      
      X3DOM_SCENE_INIT = true;
      
    }
  };
  
}

function getPO(){
  
  var cnv = document.getElementById('x3d_id');
  var vm = cnv.runtime.viewMatrix();
  
  console.log("runtime.viewMatrix():");
  console.log(vm.toString());
  
  vmi = vm.inverse();
  console.log(vmi.toString());
  
  var viewDir  = vmi.multMatrixVec(new x3dom.fields.SFVec3f(0.0, 0.0, -1.0));
  var upVec    = vmi.multMatrixVec(new x3dom.fields.SFVec3f(0.0, 1.0,  0.0));
  var rightVec = viewDir.cross(upVec);

}

function bind_shapes(){
  
  var elem = document.getElementById('x3d_id');
  
  var inlines = $(elem).find("inline");
  
  inlines.each(function(){

    if ($(this).attr("name")!="back"){
      var shapes = $(this).find("Shape");
      console.log("shapes length = "+shapes.length);
      shapes.each(function(){
        
        $(this).on("mouseover",function(e){
          var tmp = $(this).find("ImageTexture").attr("url");
          
          //console.log(tmp);
          x3dom.debug.logInfo(tmp);
          showShapeTitle(e,tmp);
          
          if (HIGHLIGHT_ON_MOUSEOVER){
            var tmpapp = $(this).find("Appearance");
            var m = $("<Material>");
            m.attr("emissiveColor","1 1 1");
            tmpapp.append(m);
          }
          
        });
        
        $(this).on("mouseout",function(e){
          var tmpapp = $(this).find("Appearance").find("Material").remove();
          hideShapeTitle();
        });
        
      });
      //console.log(this);
    }
    
    /*
    $(this).on("mouseover",function(){
      console.log($(this).attr("name"));
    });
    */
  });
  
  //console.log("shapes found: "+inlines.length);
}

function initShapeTitle(){
  var el = $("<div>",{id:"shapetitle"}).css({
    position:"absolute",
    top:"0px",
    left:"0px",
    "z-index":10,
    background:"black",
    border:"2px solid white",
    color:"white",
    padding:"5px"
  });
  $("body").append(el);
}

function showShapeTitle(e,tmp){
  $("#shapetitle").html(tmp);
}

function hideShapeTitle(){
  $("#shapetitle").html("");
}

function bind_keys(elem){
  
  elem.addEventListener('keydown',function(e){
    
    var dx = 0;
    var dy = 0;
    
    var goodkey = false;
    
    if (e.keyCode=='38'){
      //console.log("up");
      dy = 1;
    }
    if (e.keyCode=='40'){
      //console.log("down");
      dy = -1;
    }
    if (e.keyCode=='37'){
      console.log("left");
      dx = -1;
    }
    if (e.keyCode=='39'){
      //console.log("right");
      dx = 1;
    }
    
    console.log(this.runtime.viewMatrix());
     
    //firstViewarea.animateTo(secondViewarea.getViewMatrix(), firstViewarea._scene.getViewpoint(), 0);
    //vp.animateTo(x3dom.fields.SFMatrix4f.identity(),vp._scene.getViewpoint(),1);
    
    if (goodkey){
      e.preventDefault();
      e.stopPropagation();
      return false;
    }
    
  },true);
}

function getViewpointPosition(elem){
  
  var vp_mat = elem.runtime.viewMatrix();
  
  var vp_rotation = new x3dom.fields.Quaternion(0, 0, 1, 0);
  vp_rotation.setValue(vp_mat);
  
  var vp_translation = vp_mat.e3();
  
  console.log(vp_translation.toString());
  
  return vp_translation;
}

function bind_FoV(elem){
  // true = CAPTURING = from parent to child
  // canvas is a child of x3d
  
  //Chrome?!
  elem.addEventListener('mousewheel',function(e){

    //if (e.ctrlKey) {

      var delta = (e.deltaY>0)?0.05:-0.05;

      fov = getFoV(this)+delta;

      setFoV(this,fov);

      e.preventDefault();
      e.stopPropagation();
      return false;
    //}
    
  },true);
  
  //Firefox?!
  elem.addEventListener('DOMMouseScroll',function(e){

    //if (e.ctrlKey) {
      
      var delta = (e.detail>0)?0.05:-0.05;

      fov = getFoV(this)+delta;

      setFoV(this,fov);

      e.preventDefault();
      e.stopPropagation();
      return false;
    //}
    
  },true);  
  
}


function setFoV(elem,val){

  var vp = $(elem).find("Viewpoint")[0];
  $(vp).prop("fieldOfView",val);
  
}

function getFoV(elem){

  var vp = $(elem).find("Viewpoint")[0];
  return parseFloat($(vp).prop("fieldOfView"));
  
}
