
$(function(){
  light_init();
});

function light_init(){
  
  $.ajax({
    url: "kml/test.kml",
    success: function(data){
      
      //console.log(data);
      
      var marker = [
        parseFloat($(data).find("Camera").find("latitude").text()),
        parseFloat($(data).find("Camera").find("longitude").text())
      ];
      
      var heading = parseFloat($(data).find("Camera").find("longitude").text());
      
      init_maps(marker);
      
      draw_axes(heading);
    },
  });
  
  
}

function draw_axes(heading){
  
}

var map;

function init_maps(center){

  var elphelinc = center;//[40.7233861, -111.9328843];
  
  // https: also suppported.
  var Esri_WorldImagery = L.tileLayer(
    'https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}', 
    {
      maxZoom: 21,
      attribution: 'Tiles &copy; Esri &mdash; Source: Esri, i-cubed, USDA, USGS, AEX, GeoEye, Getmapping, Aerogrid, IGN, IGP, UPR-EGP, and the GIS User Community'
    }
  );

  var googleSat = L.tileLayer(
    'https://{s}.google.com/vt/lyrs=s&x={x}&y={y}&z={z}',
    {
      maxZoom: 21,
      subdomains:['mt0','mt1','mt2','mt3'],
      attribution: 'Many thanks to Google'
    }
  );
  
  map = L.map('leaflet_map',{
    layers:[Esri_WorldImagery,googleSat]
  }).setView(elphelinc, 19);

  var baseMaps = {
    "esri world imagery": Esri_WorldImagery,
    "google superior": googleSat
  };
  
  //Esri_WorldImagery.addTo(map);
  //googleSat.addTo(map);
  
  L.control.layers(baseMaps).addTo(map);
 
  drawCamera(elphelinc);
  
}

function drawCamera(center){
  
  var p0 = map.latLngToLayerPoint(center);
  
  var pz = map.layerPointToLatLng(new L.Point(p0.x,p0.y+100));
  var px = map.layerPointToLatLng(new L.Point(p0.x+100,p0.y));
  
  var ax = Array(center,pz);
  var lx = L.polyline(ax, {color: 'blue', weight:3}).addTo(map);
  
  var az = Array(center,px);
  var lz = L.polyline(az, {color: 'red', weight:3}).addTo(map);    
  
  var ph = map.layerPointToLatLng(new L.Point(p0.x,p0.y-200));
  var ah = Array(center,ph);
  var lh = L.polyline(ah, {color: 'white', weight:1, dashArray:"5,10"}).addTo(map);
  
  var circle = L.circle(center, {
      color: '#191',
      fillColor: '#0f3',
      fillOpacity: 0.5,
      radius: 1.5
  });//.addTo(map);
  
  map.addLayer(circle);
  
  lh.on('click',function(e){
    console.log("Polyclicked!");
  });
  
  /* does not work
  circle.addEventListener('mousedown',function(e){
    console.log(e);
    e.originalEvent.preventDefault();
    e.originalEvent.stopPropagation();
    return false;
  },true);
  */
  
  circle.on({
    'mousedown': function(){
      leaflet_disable();
      map.on('mousemove', function(e) {
        circle.setLatLng(e.latlng);
      });
    },
    'click': function(){
      map.off('mousemove');
      leaflet_enable();
    }
  });
  
  /*
  circle.on('dragend',function(e){
    console.log(e);
    var marker = e.target;
    var position = marker.getLatLng();
    marker.setLatLng(position,{id:"uni",draggable:'true'});
  });
  */
  
  circle.on("click",function(e){

    /*
    L.circle(p1,{
      color: '#119',
      fillColor: '#03f',
      fillOpacity: 0.5,
      radius: 1.5
    }).addTo(map);
    
    L.circle(p2,{
      color: '#911',
      fillColor: '#f30',
      fillOpacity: 0.5,
      radius: 1.5
    }).addTo(map);
    */
  });
}

function leaflet_disable(){
  map._handlers.forEach(function(handler) {
    handler.disable();
  });
}

function leaflet_enable(){
  map._handlers.forEach(function(handler) {
    handler.enable();
  });
}
