/* 
 * TODO:
 *    * 
 * 
 */

// http://stackoverflow.com/questions/9394190/leaflet-map-api-with-google-satellite-layer

// http://leafletjs.com/examples/extending/extending-1-classes.html
// - extend or include

$(function(){
  light_init();
});

function light_init(){
  
  $.ajax({
    url: "kml/test.kml",
    success: function(data){
      
      //console.log(data);
      
      var marker = [
        parseFloat($(data).find("Camera").find("latitude").text()),
        parseFloat($(data).find("Camera").find("longitude").text())
      ];
      
      var heading = parseFloat($(data).find("Camera").find("longitude").text());
      
      init_maps(marker);
      
      draw_axes(heading);
    },
  });
  
  
}

function draw_axes(heading){
  
}

var map;
var markers = Array();

function init_maps(center){

  var elphelinc = center;//[40.7233861, -111.9328843];
  
  // https: also suppported.
  var Esri_WorldImagery = L.tileLayer(
    'https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}', 
    {
      maxZoom: 21,
      attribution: 'Tiles &copy; Esri &mdash; Source: Esri, i-cubed, USDA, USGS, AEX, GeoEye, Getmapping, Aerogrid, IGN, IGP, UPR-EGP, and the GIS User Community'
    }
  );

  var googleSat = L.tileLayer(
    'https://{s}.google.com/vt/lyrs=s&x={x}&y={y}&z={z}',
    {
      maxZoom: 21,
      attribution: 'Many thanks to Google for our happy childhood',
      subdomains:['mt0','mt1','mt2','mt3'],
    }
  );
  
  var OSMTiles = L.tileLayer('http://a.tile.openstreetmap.org/{z}/{x}/{y}.png', 
    {
      maxZoom: 21,
      attribution: 'Map data and images &copy; <a href="http://openstreetmap.org">OpenStreetMap</a> contributors, <a href="http://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>'
    }
  );
  
  map = L.map('leaflet_map',{
    layers:[googleSat]
  }).setView(elphelinc, 17);

  var baseMaps = {
    "Esri world imagery": Esri_WorldImagery,
    "Google": googleSat,
    "Open Street Map": OSMTiles
  };
  
  //Esri_WorldImagery.addTo(map);
  //googleSat.addTo(map);
  
  //custom control:
  //http://www.coffeegnome.net/control-button-leaflet/
  
  L.control.layers(baseMaps).addTo(map);
 
  drawCamera(elphelinc);
  
}

function drawCamera(basepoint){
  
  var circle = L.cameraViewMarker(basepoint, {
      color: '#191',
      fillColor: '#0f3',
      fillOpacity: 0.5,
      radius: 10,
      heading: 45,
      id: "basecircle"
  }).addTo(map);
  
  circle.on({
    'mousedown': function(e){
      console.log(this);
      console.log(this.options.id);
      leaflet_disable();
      map.on('mousemove', function(e) {
        circle.setLatLng(e.latlng);
      });
    },
    'click': function(){
      map.off('mousemove');
      leaflet_enable();
    }
  });
  
  /*
  circle2 = L.circleMarker(ph, {
      color: 'white',
      fillColor: 'white',
      fillOpacity: 0.1,
      radius: 10,
      id: "headingcircle"
  }).addTo(map);
  
  circle2.on({
    'mousedown': function(e){
      leaflet_disable();
      dragStartHandler(this,e);
      var elem = this;
      map.on('mousemove', function(e) {
        circle2.setLatLng(e.latlng);
        dragHandler(elem,e);
      });
    },
    'click': function(e){
      map.off('mousemove');
      dragEndHandler(this,e);
      leaflet_enable();
    }
  });
  */
  /*
  circle2.bindTooltip('Even polylines can have labels.',{
    permanent:"true",
    direction:"top",
    offset:[0,-20],
  }).openTooltip();
  */
  
  //circle.on('dragstart', dragStartHandler).on('drag', dragHandler).on('dragend', dragEndHandler);
  //circle2.on('dragstart', dragStartHandler).on('drag', dragHandler).on('dragend', dragEndHandler);
  /*
  var bb = polyline.getBounds().getCenter();
  
  //bbmarker = new L.marker(bb, { opacity: 0.01 }); //opacity may be set to zero
  
  bbmarker = L.circleMarker(bb,{
    color: 'white',
    fillColor: 'white',
    fillOpacity: 0.1,
    opacity: 0.01,
    radius:2
  });
  
  bbmarker.bindTooltip("My Label", {
    direction: 'right',
    permanent: true, 
    id: "bbmarker",
    className: "bbmarker",
    offset: [0, 0]
  });
  bbmarker.addTo(map);
  */
  //drawTooltip();
  
}

// http://www.movable-type.co.uk/scripts/latlong.html
// initial bearing
function getAzimuth(p1,p2){
  //p1 - start point
  //p2 - end point
  
  var dlat = p2.lat-p1.lat;
  var dlon = p2.lng-p1.lng;

  var y = Math.sin(dlon)*Math.cos(p2.lat);
  var x = Math.cos(p1.lat)*Math.sin(p2.lat)-Math.sin(p1.lat)*Math.cos(p2.lat)*Math.cos(dlon);
  
  var azimuth = ((2*Math.PI - Math.atan2(y,x))*180/Math.PI) % 360;
  
  return azimuth;
}

function getLineAngle(p1,p2){
  var res = 0;
  var px1 = map.latLngToLayerPoint(p1);
  var px2 = map.latLngToLayerPoint(p2);
  
  var dx = px2.x - px1.x;
  var dy = px2.y - px1.y;
  
  res = -Math.abs(Math.atan2(dx,dy)*180/Math.PI);
  
  return res;
}

// http://stackoverflow.com/questions/33513404/leaflet-how-to-match-marker-and-polyline-on-drag-and-drop
function dragStartHandler(elem,e){

    // Get the polyline's latlngs
    var latlngs = polyline.getLatLngs();
    
    // Get the marker's start latlng
    var latlng = elem.getLatLng();

    // Iterate the polyline's latlngs
    for (var i = 0; i < latlngs.length; i++) {

        // Compare each to the marker's latlng
        if (latlng.equals(latlngs[i])) {

            // If equals store key in marker instance
            elem.polylineLatlng = i;
        }
    }
}

function dragHandler(elem,e){

    // Get the polyline's latlngs
    var latlngs = polyline.getLatLngs();

    // Get the marker's current latlng
    var latlng = elem.getLatLng();

    // Replace the old latlng with the new
    latlngs.splice(elem.polylineLatlng, 1, latlng);
    
    // Update the polyline with the new latlngs
    polyline.setLatLngs(latlngs);
    
    drawTooltip();
}

function dragEndHandler(elem,e){
  
    drawTooltip();
    // Delete key from marker instance
    delete elem.polylineLatlng;
}

function drawTooltip(){
  
    var res = 0;
    var res0 = 0;
    var latlngs = polyline.getLatLngs();
    for(var i=1;i<latlngs.length;i++){
       res0 = getAzimuth(latlngs[i-1],latlngs[i]);
       res = Math.round(res0*100)/100;
       
       dist = latlngs[i-1].distanceTo(latlngs[i]);
       dist = Math.round(dist*100)/100;
    }
  
    var bb = polyline.getBounds().getCenter();
    
    bbmarker.setLatLng(bb);
    bbmarker._tooltip.setContent("Azimuth = "+res+"&deg; Distance = "+dist+" m");
    
    var element = $.find(".bbmarker");

    var div = element[0];
    var w = $(div).width();
    var h = $(div).height();
    
    div.style.left = (-w/2)+'px';
    div.style.top = '0px';
    
    //http://stackoverflow.com/questions/19126432/rotate-a-div-using-javascript
    //rotate by rads: 
    // .example {
    //    transform: rotate(6.2831853rad);
    //  }
    /*
    div.style.webkitTransform = 'rotate('+deg+'deg)'; 
    div.style.mozTransform    = 'rotate('+deg+'deg)'; 
    div.style.msTransform     = 'rotate('+deg+'deg)'; 
    div.style.oTransform      = 'rotate('+deg+'deg)'; 
    div.style.transform       = 'rotate('+deg+'deg)';

    var tmpp = map.latLngToLayerPoint(bb);

    div.style.left = (tmpp.x)+'px';
    div.style.top = (tmpp.y)+'px';
    */
}

// https://gis.stackexchange.com/questions/54454/disable-leaflet-interaction-temporary
function leaflet_disable(){
  map._handlers.forEach(function(handler) {
    handler.disable();
  });
}

function leaflet_enable(){
  map._handlers.forEach(function(handler) {
    handler.enable();
  });
}
